# SYNOPSIS
#
#   AX_MKL([ACTION-IF-FOUND[, ACTION-IF-NOT-FOUND]])
#

AU_ALIAS([ACX_MKL], [AX_MKL])
AC_DEFUN([AX_MKL], [
AC_PREREQ(2.50)

ax_mkl_ok=no

AC_ARG_WITH(mkl_dir,
	[AS_HELP_STRING([--with-mkl=<dir>], [use MKL installation in <dir>])])
case $with_mkl_dir in
	yes | "") ;;
	no) ax_mkl_ok=disable ;;
esac

AC_ARG_WITH(mkl_thread,
	[AS_HELP_STRING([--with-mkl-thread=<lib>], [use MKL threading library <lib> (e.g. sequential, intel_thread)])])
case $with_mkl_thread in
     intel_thread | pgi_thread | sequential | gnu_thread	) ;;
     *) AC_MSG_ERROR([Unknown MKL threading layer: $with_mkl_threading]) ;;
esac

if test $ax_mkl_ok = no; then
   # could test for architecture as only one will work
   AC_ARG_WITH(mkl_arch,
   	[AS_HELP_STRING([--with-mkl-arch=<32/64/em64t>], [use MKL libraries for the specified architecture])])
	case $with_mkl_arch in
	     32) ax_mkl_64bit=no ;;
	     64 | em64t| intel64 ) ax_mkl_64bit=yes ;;
	     *) AC_MSG_ERROR([Unknown MKL architecture: $with_mkl_arch]) ;;
	esac
fi

ax_mkl_save_CPPFLAGS="$CPPFLAGS"
CPPFLAGS="-I$with_mkl_dir/include"
LDFLAGS="-L$with_mkl_dir/lib/$with_mkl_arch"
AC_MSG_CHECKING([for MKL support in $with_mkl_dir/lib/$with_mkl_arch])
AC_SEARCH_LIBS( [ddtsvb], [mkl_intel_lp64], [ax_mkl_ok=yes], [ax_mkl_ok=no; AC_MSG_ERROR(cannot find MKL fortran library)], [-lmkl_intel_thread -lmkl_core -lpthread])
AC_MSG_RESULT($ax_mkl_ok)
CPPFLAGS="$ax_mkl_save_CPPFLAGS"

# now set libraries
MKL_LIBS="-lmkl_intel$mkl_interface -lmkl_$with_mkl_thread -lmkl_core"

# Finally, execute ACTION-IF-FOUND/ACTION-IF-NOT-FOUND:
if test x"$ax_mkl_ok" = xyes; then
   MKLROOT="$with_mkl_dir/lib/$with_mkl_arch"
   ac_want_mkl=yes
   AC_SUBST(ac_want_mkl)
   AC_SUBST(MKLROOT)
   ifelse([$1],,AC_DEFINE(HAVE_MKL,1,[Define if you have an MKL installation.]),[$1])
        :
else
        ax_mkl_ok=no
        $2
fi
])
