AC_DEFUN([HAVE_GRIB_API_CHECK],[
AC_ARG_WITH(grib_api-dir,
[ --with-grib_api-dir=DIR prefix for grib_api root files],
[if test "$withval" = "no"; then
	NC_DIR=
    NC_INDIVIDUAL="yes"
 else
	NC_DIR="$withval"
    NC_INDIVIDUAL="no"
 fi],
[NC_DIR=/usr/local/])
if test "x$nc_individual" = xno; then
	AC_ARG_WITH(grib_api-lib-dir,
	[ --with-grib_api-lib-dir=DIR prefix for grib_api library files],
	[if test "$withval" = "no"; then
		NC_LIBS_DIR=
	else
		NC_LIBS_DIR="$withval"
	fi],
	[NC_LIBS_DIR=/usr/local/lib])
	
	AC_ARG_WITH(grib_api-include-dir,
	[ --with-grib_api-include-dir=DIR prefix for grib_api headers],
	[if test "$withval" = "no"; then
		NC_INCLUDES_DIR=
	else
		NC_INCLUDES_DIR="$withval"
	fi],
	[NC_INCLUDES_DIR=/usr/local/include])
	
else

  NC_LIBS_DIR="$NC_DIR/lib"
  NC_INCLUDES_DIR="$NC_DIR/include"

fi


	AC_CHECKING([for grib_api])
	
	AC_MSG_RESULT([grib_api lib location: $NC_LIBS_DIR])
	AC_MSG_RESULT([grib_api headers location: $NC_INCLUDES_DIR])
	
	if eval "test ! -d $NC_INCLUDES_DIR"; then
	AC_MSG_ERROR([$NC_INCLUDES_DIR not found])
	fi
	
	if eval "test -d $NC_LIBS_DIR"; then
	NC_LDFLAGS="-L$NC_LIBS_DIR"
	NC_LIBS="-lgrib_api"
	else
	AC_MSG_ERROR([$NC_LIBS_DIR not found])
	fi
	
	save_CPPFLAGS="$CPPFLAGS"
	save_LDFLAGS="$LDFLAGS"
	save_LIBS="$LIBS"
	
	CPPFLAGS="$CPPFLAGS -I$NC_INCLUDES_DIR"
	LIBS="$LIBS $NC_LIBS"
	LDFLAGS="$LDFLAGS $NC_LDFLAGS"
	
	grib_api=no
	
	AC_CHECKING([for grib_api.h])
	AC_CHECK_HEADER([grib_api.h],
	[grib_api=yes], [grib_api=no])
	
	AC_MSG_RESULT([grib_api include result: $grib_api])
	if test "x$grib_api" = xno; then
	AC_MSG_ERROR([grib_api include not found])
	fi
	
	AC_CHECKING([for libgrib_api.a])
	AC_CHECK_LIB([grib_api], [main],
	[grib_api=yes], [grib_api=no])
	
	AC_MSG_RESULT([grib_api link result: $grib_api])
	if test "x$grib_api" = xno; then
	AC_MSG_ERROR([grib_api library not found])
	fi
	
	CPPFLAGS="$save_CPPFLAGS"
	LDFLAGS="$save_LDFLAGS"
	LIBS="$save_LIBS"
	
	AC_SUBST(GRIB_API_DIR, [$NC_DIR])
	AC_SUBST(GRIB_API_INCLUDE, [$NC_INCLUDES_DIR])
	AC_SUBST(GRIB_API_CPPFLAGS, [-I$NC_INCLUDES_DIR])
	AC_SUBST(GRIB_API_LDPATH, [$NC_LIBS_DIR])
	
	]) 
