module cmod_miscvars

  !- implicit directive --------------------------------------------------------
  private

  character(2)    , public :: c2
  integer(4)      , public :: ii, jstuna, ija_akt, imon_akt, itg_akt, irc, lun
  integer(4)      , public :: indt, ndt, ia, ios, iia, iao, iif
  integer(4)      , public :: nz1, nz2, nu1, nu2, nv1, nv2
  integer(4)      , public :: iday, imon, iyyy, ihour, minut, nsecs
  real(8)         , public :: trest
  logical         , public :: DoAdvec, DoDiff, DoGatherC

  logical,       save, public :: upd = .true.
  logical,       save, public :: DoGather1 = .false., DoGather2 = .false.
  logical,       save, public :: tidal, tidal_surge, wforc, qforc
  integer(4),    save, public :: lunsurge, rclsurge
  integer(4),    save, public :: nb1 = 1, nb2 = 1
  integer(4),    save, public :: NDTFC    = 2
  integer(4),    save, public :: ntracers = 2
  integer(4),    save, public :: ischfac, ioff = 1, irmaxa
  integer(4),    save, public :: itime, izeite, lmns, lmnts, lmn, lmn1
  integer(4),    save, public :: lmne, i2, lmn2
  real(8),       save, public :: schfactor
  real(8),       save, public :: tima, time, tim1, tmet
  real(8),       save, public :: dt3600, dtice, dtday, dtspong, dtmain
  real(8),       save, public :: dtadvec, dtvdiff, dtthermo, dteddy, dticedyn
  character(2),  save, public :: sch = '12'
  character(11), save, public :: mdatei
  character(19), save, public :: cta, cte, ctim, ctim1, cmet

  !- Constants -----------------------------------------------------------------
  integer(4), parameter, public :: izeita = 1        ! time step No. at start
  real(8),    parameter, public :: advecstab = 1.0_8 ! stabilizer for advection

  !- Namelist parameters -------------------------------------------------------
  integer(4), save, public :: NDTADVEC  =  2
  integer(4), save, public :: NDTVDIFF  =  2
  integer(4), save, public :: NDTEDDY   =  2
  integer(4), save, public :: NDTSMAG   =  0
  integer(4), save, public :: NDTTHERMO =  2
  integer(4), save, public :: ndticedyn = 10
  integer(4), save, public :: schedule  = 12
  logical,    save, public :: OPRFMT    = .false.
  logical,    save, public :: lvalidate = .false.
  real(8),    save, public :: sstmin    =  -1.8_8
  real(8),    save, public :: sstmax    =  30.0_8
  real(8),    save, public :: sstsat    =   1.2_8
  real(8),    save, public :: dtdscale  =   1.0_8
  real(8),    save, public :: dtsurge   = 900.0_8 ! *must* match surge-mod for 
                                                 ! open boundary data!
                                                 ! This size matches DMI-noamod
  real(8),    save, public :: dttsbnd   =   0.0_8 ! Should be zero, if no high 
                                                 ! resolution model ts-boundary
                                                 ! data is available-else it 
                                                 ! *must* match the ts-mod
                         
  ! FIXME: printmetstats is only intended for temporary use till nightly
  !        build refs have been modified accordingly
  logical,    save, public :: printmetstats = .false.

  namelist /cmodcfg/ NDTADVEC,NDTVDIFF,NDTEDDY,NDTSMAG,NDTTHERMO,ndticedyn,    &
                     OPRFMT,lvalidate,sstmin,sstmax,sstsat,                    &
                     dtdscale,dtsurge,dttsbnd,schedule, printmetstats
  public :: cmodcfg

end module cmod_miscvars
