module io_subs
  !-----------------------------------------------------------------------------
  !
  ! Module containing methods for handling I/O
  !
  !   io_new_unit()
  !   flush_unit()
  !
  ! Per Berg, DMI.
  !
  !-----------------------------------------------------------------------------

  !- modules -------------------------------------------------------------------
  !  none so far ...

  !- directives ----------------------------------------------------------------
  implicit none
  private

  !- public routines -----------------------------------------------------------
  public :: io_new_unit, flush_unit

  !- private routines ----------------------------------------------------------
  !  none so far ...

  !- public vars ---------------------------------------------------------------
  !  none so far ...

  !- private vars --------------------------------------------------------------
  !  none so far ...

contains

!- Public routines -------------------------------------------------------------

  !-----------------------------------------------------------------------------
  integer(4) function io_new_unit ()

    use exits, only : exitme

    integer(4) :: i
    logical    :: file_is_open
    integer(4), parameter :: io_min=7, io_max=130

    file_is_open = .true.
    i = io_min-1
    do while (file_is_open)
      i = i+1
      if (i > io_max) then
        call exitme('ERROR: Could not find new I/O unit number')
      endif
      inquire(unit=i,opened=file_is_open)
    enddo

    io_new_unit = i

  end function io_new_unit

  !-----------------------------------------------------------------------------

  subroutine flush_unit ( lun )
    use port_flush, only : portable_flush
    use exits, only : exitme
    integer(4), intent(in) :: lun
    logical :: file_is_open

    inquire(unit=lun,opened=file_is_open)
    if (.not.file_is_open) call exitme('ERROR: Cannot flush non-opened file')
    call portable_flush( lun ) 
  end subroutine flush_unit

  !-----------------------------------------------------------------------------

end module io_subs
