module trisolver
  implicit none
  private
  public :: trisolv
contains 

  subroutine trisolv(dl, d, du, b, n)
  !-----------------------------------------------------------------------------
  ! wrapper for the default LAPACK solver
  !-----------------------------------------------------------------------------

    !- directives --------------------------------------------------------------
    implicit none

    !- arguments ---------------------------------------------------------------
    integer(4), intent(in) :: n
    real(8), intent(inout) :: dl(1:), d(1:), du(1:), b(:)

    !- local vars --------------------------------------------------------------
    integer(4) :: info

!dir$ inline
    call dgtsv(n, 1, dl, d , du , b, n, info)

  end subroutine trisolv

end module trisolver

