module trisolver
  implicit none
  private
  public :: trisolv
contains 

  subroutine trisolv(dl, d, du, b, n)
  !-----------------------------------------------------------------------------
  ! wrapper for the  MKL solver
  !-----------------------------------------------------------------------------

    !- directives --------------------------------------------------------------
    implicit none
!DEC$ NOFREEFORM
       include 'mkl.fi'
!DEC$ FREEFORM

    !- arguments ---------------------------------------------------------------
    integer(4), intent(in) :: n
    real(8), intent(inout) :: dl(1:), d(1:), b(:)
    real(8), intent(in)    :: du(1:)

    !- local vars --------------------------------------------------------------
    integer(4) :: info

!dir$ inline
    call ddtsvb (n, 1, dl, d , du , b, n, info)

  end subroutine trisolv

end module trisolver

